<?php
// +----------------------------------------------------------------------+
// | Author:  Evgeny Leontev <gmail@ezactive.com>                         |
// | Copyright (c) 2005 Evgeny Leontev                                    |
// +----------------------------------------------------------------------+
// | This source file is free software; you can redistribute it and/or    |
// | modify it under the terms of the GNU Lesser General Public           |
// | License as published by the Free Software Foundation; either         |
// | version 2.1 of the License, or (at your option) any later version.   |
// |                                                                      |
// | This source file is distributed in the hope that it will be useful,  |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    |
// | Lesser General Public License for more details.                      |
// +----------------------------------------------------------------------+

require_once 'phpmailer/class.phpmailer.php';
require_once 'core/app/AppMailModel.php';
require_once 'eleontev/Util/Replacer.php';

class AppMailSender
{

	var $charset = 'iso-8859-1';
	var $from;
	var $from_name;
	var $subject;
	var $noreplay_email;
	
	
	function AppMailSender() {
		
		$reg =& Registry::instance();
		$this->conf =& $reg->getEntry('conf');
		
		$this->model = &new AppMailModel();
		
		$this->replacer = new Replacer;
		$this->replacer->s_var_tag = "[";		 // var tags
		$this->replacer->e_var_tag = "]";
		
		
		$this->charset = $this->conf['lang']['meta_charset'];
		$this->noreplay_email = 'noreplay@'.$_SERVER['HTTP_HOST'];
	}


	function generatedPassword($password, $link, $user) {
	
		$mail = new PHPMailer();
		$mail->CharSet = $this->charset;
		$mail->From = $this->noreplay_email;
		$mail->FromName = '';
		$mail->Subject = 'New password';
		$mail->AddAddress($user['email']); // name can be used for second argument
		
		$tpl = new tplTemplatez(APP_EMAI_TMPL_DIR . 'generated_password.txt');
		$tpl->clean_html = false;
		
		$tpl->tplAssign('name', $user['first_name'] . ' ' . $user['last_name']);
		$tpl->tplAssign('login', $user['username']);
		$tpl->tplAssign('password', $password);
		$tpl->tplAssign('link', $link);
		
		$tpl->tplParse();
		$mail->Body = $tpl->tplPrint(1);
		//echo "<pre>"; print_r($mail); echo "</pre>";exit();	
				
		return $mail->Send();
	}
	
	
	function sendAnswer() {
		
		$template = $this->model->getTemplate('answer_to_user');
		
		
		$mail = new PHPMailer();
		$mail->CharSet = $this->charset;
		$mail->From = $this->from;
		$mail->FromName = $this->from_name;
		$mail->Subject = $template['subject'];
		$mail->AddAddress($this->vars['email']); // name can be used for second argument
		 
		$this->replacer->assign($this->vars);
		
		$mail->Body = $this->replacer->parse($template['body']);
		return $mail->Send();
	}
	
	
	function parseAnswer() {
		
		$template = $this->model->getTemplate('answer_to_user');
		$this->replacer->assign($this->vars);
		
		return $this->replacer->parse($template['body']);
	}
}
?>