<?php
// +----------------------------------------------------------------------+
// | Author:  Evgeny Leontev <eleontev@gmail.com>                         |
// | Copyright (c) 2005 Evgeny Leontev                                    |
// +----------------------------------------------------------------------+
// | This source file is free software; you can redistribute it and/or    |
// | modify it under the terms of the GNU Lesser General Public           |
// | License as published by the Free Software Foundation; either         |
// | version 2.1 of the License, or (at your option) any later version.   |
// |                                                                      |
// | This source file is distributed in the hope that it will be useful,  |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    |
// | Lesser General Public License for more details.                      |
// +----------------------------------------------------------------------+

class RequestDataUtil
{
	
	function toInt(&$arr, $keys) {
		foreach($keys as $k => $v) {
			if(array_key_exists($v, $arr)) {
				$arr[$v] = (int) $arr[$v];
			}
		}
		
		return $arr;
	}
	
	
	function _getRules() {
		$a['search']  = array('&quot;', '&#039;', '&gt;', '&lt;', '&amp;');
		$a['replace'] = array('"',      "'",      '>',    '<',    '&');
		return $a;
	}
	
	
/*
	// recursive
	// working with $_POST or $_GET variables change < to &lt; and so on
	// to be able to show the same after submit and error
	// by default $server_check = false, if true than we check errors on server side 
	// and after check before insert in db need to call - stripVars($arr, false);
	function & stripVars2(&$arr, $skip_keys = array(), $server_check = false, $wordrap_num = 75) {
		
		if(!is_array($arr)) { 
			$a =  RequestDataUtil::stripVars(array('temp'=>$arr), $skip_keys, $server_check, $wordrap_num);
			return $a['temp'];
		}		
		
		foreach($arr as $k => $v){
			if(is_array($v)) {
				$arr[$k] = RequestDataUtil::stripVars($v, $skip_keys, $server_check, $wordrap_num);
			} else {
				if(in_array($k, $skip_keys)) {$arr[$k] = $arr[$k]; continue; }
				$arr[$k] = wordwrap(stripslashes(trim(htmlspecialchars($v))), $wordrap_num, ' ', 1);
				if(empty($server_check)) { 
					//$arr[$k] = str_replace(array('&quot;', '&gt;', '&lt;', '&amp;'), array('"', '>', '<', '&'), $arr[$k]);			
					$arr[$k] = addslashes(str_replace('&quot;', '"', $arr[$k])); 
				}
			}
		}
		return $arr;
	}
*/
	
	function _stripVar(&$value, $rules, $server_check = false, $wordrap_num = 75) {
		
		// to db
		if(empty($server_check)) {
			$value = wordwrap(addslashes(stripslashes(trim(str_replace($rules['search'], $rules['replace'], $value)))), $wordrap_num, ' ', 1); 
		
		// to display
		} else {
			$value = str_replace($rules['search'], $rules['replace'], $value); // for compability
			$value = stripslashes(htmlspecialchars($value));
		}
		
		return $value;
	}
	
	
	function &stripVars(&$arr, $skip_keys = array(), $server_check = false, $wordrap_num = 75) {
		
		$rules = RequestDataUtil::_getRules();
		
		if(!is_array($arr)) {
			return $arr = RequestDataUtil::_stripVar($arr, $rules, $server_check, $wordrap_num);
		}
		
		foreach($arr as $k => $v) {
			if(is_array($v)) {
				$arr[$k] = RequestDataUtil::stripVars($v, $skip_keys, $server_check, $wordrap_num);
			} else {
				if(in_array($k, $skip_keys)) {$arr[$k] = $arr[$k]; continue; }

				// to db
				//if(empty($server_check)) {
				//	$arr[$k] = wordwrap(addslashes(stripslashes(trim(str_replace($rules['search'], $rules['replace'], $arr[$k])))), $wordrap_num, ' ', 1); 
				
				// to display
				//} else {
				//	$v = str_replace($rules['search'], $rules['replace'], $v); // for compability
				//	$arr[$k] = stripslashes(htmlspecialchars($v));
				//}
				
				$arr[$k] = RequestDataUtil::_stripVar($arr[$k], $rules, $server_check, $wordrap_num);
			}
		}
		
		///echo "<pre>"; print_r($arr); echo "</pre>";
		return $arr;
	}
	
	
	function _stripVarHtml(&$value, $server_check = false) {
		
		// to db
		if(empty($server_check)) {
			$value = addslashes(stripslashes($value)); 
		
		// to display
		} else {
			$value = stripslashes($value);
		}
		
		return $value;
	}
	
	
	function &stripVarsHtml(&$arr, $skip_keys = array(),  $server_check = false) {
		
		if(!is_array($arr)) {
			return $arr = RequestDataUtil::_stripVarHtml($arr, $server_check);
		}
		
		foreach($arr as $k => $v){
			if(is_array($v)) {
				$arr[$k] = RequestDataUtil::stripVarsHtml($v, $skip_keys, $server_check);
			} else {
				if(in_array($k, $skip_keys)) {$arr[$k] = $arr[$k]; continue; }
				//$arr[$k] = stripslashes($v);
				//if(empty($server_check)) { $arr[$k] = addslashes($arr[$k]); }
				
				$arr[$k] = RequestDataUtil::_stripVarHtml($arr[$k], $server_check);
			}
		}
		
		return $arr;
	}
}

/*
'&' (ampersand) becomes '&amp;' 
'"' (double quote) becomes '&quot;' when ENT_NOQUOTES is not set. 
''' (single quote) becomes '&#039;' only when ENT_QUOTES is set. 
'<' (less than) becomes '&lt;' 
'>' (greater than) becomes '&gt;'
*/


/*
$data = array('html'=>'<br>adasd " dflksdfk',
              'text'=>'jjhasjk " laksdlk <>');
			  
			  
echo "<pre>"; print_r(RequestDataUtil::stripVarsHtml($data['html'])); echo "</pre>";
echo "<pre>"; print_r(RequestDataUtil::stripVars($data, array(), true)); echo "</pre>";
*/
?>