<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

require_once $controller->working_dir . 'inc/KBCategory.php';
require_once $controller->working_dir . 'inc/KBCategoryModel.php';


// initialize objects
$rq =& new RequestData($_GET);
$rp =& new RequestData($_POST);

$obj = new KBCategory;

$manager =& $obj->setManager(new KBCategoryModel());
$manager->checkPriv($priv, $controller->action, @$rq->id);


switch ($controller->action) {
case 'delete': // ------------------------------
	
	$msg = $manager->delete($rq->id, $rq->parent_id);
	
	$success = ($msg == 'success') ? false : true;
	$controller->go($msg, $success);

	break;
	

case 'status': // ------------------------------
	
	$manager->status($rq->status, $rq->id);
	$controller->go();

	break;
	
	
case 'update': // ------------------------------
case 'insert': // ------------------------------
	
	if(isset($rp->submit)) {
		
		$is_error =& $obj->validate($rp->vars);
		
		if($is_error) {
			$rp->stripVars(true);
			$obj->set($rp->vars);
			
			if(!empty($rp->vars['admin_user'])) {
				$ids = implode(',', $rp->vars['admin_user']);	
				$obj->setAdminUser($manager->getAdminUserByIds($ids));
			}	
		
		} else {
			$rp->stripVars();
			$obj->set($rp->vars);
			$obj->setAdminUser(@$rp->vars['admin_user']);
		
			$manager->save($obj, $controller->action);
			
			$controller->go();
		}
		
	} elseif($controller->action == 'update') {
	
		$data = &$manager->getById($rq->id);
		$rp->stripVarsValues($data, true);
		$obj->set($data);
		
		if($manager->isExtra('notify_admin_category')) {
			$obj->setAdminUser($manager->getAdminUserById($rq->id));
		}
	}
	
	$view = &$controller->getView($obj, $manager, 'KBCategoryView_form');

	break;


default: // ------------------------------------
	
	$view = &$controller->getView($obj, $manager, 'KBCategoryView_list');
}
?>