<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

class KBEntryView_list extends AppView
{
	
	var $template = 'list.html';
	var $template_popup = 'list_popup.html';
	
	
	function execute(&$obj, &$manager) {
		
		$tmpl = ($this->controller->getMoreParam('popup')) ? $this->template_popup :  $this->template;
		$add_button = ($this->controller->getMoreParam('popup')) ? false :  true;
		
		$tpl = &new tplTemplatez($this->template_dir . $tmpl);
		
		if($manager->isExtra('file')) {
			$tpl->tplSetNeededGlobal('attachment');
		}
		
		
		// setting/fields 
		$s = &new SettingModel;
		$s->module_id = 100; 
		$setting = &$s->getSettings();		
		
		if($setting['allow_comments']) { $tpl->tplSetNeededGlobal('comment'); } 
		if($setting['allow_rating'])   { $tpl->tplSetNeededGlobal('rating'); } 
		
		
		
		// filter sql
		$categories = $manager->getCategoryRecords();
		$manager->setSqlParams($this->getFilterSql($manager, $categories));
		
		// header generate
		$bp = &$this->pageByPage($manager->limit, $manager->getCountRecordsSql());
		$tpl->tplAssign('header', $this->commonHeaderList($bp->nav, $this->getFilter($manager, $categories), $add_button));
		
		// sort generate
		$sort = &$this->getSort();
		$manager->setSqlParamsOrder($sort->getSql());

		// get records
		$rows = &$this->stripVars($manager->getRecords($bp->limit, $bp->offset));
		//echo "<pre>"; print_r($rows); echo "</pre>";		
		
		$ids = $manager->getValuesString($rows, 'id'); 
		$categories = ($ids) ? $manager->getCategoryByIds($ids) : array();
		$categories = &$this->stripVars($categories);
		
		
		// list records
		foreach($rows as $row) {
			
			$obj->set($row);
			
			$tpl->tplAssign('escaped_title', addslashes($obj->get('title')));			
			$tpl->tplAssign('formated_date', $this->getFormatedDate($row['ts']));
			$tpl->tplAssign('category', implode('<br>', $categories[$row['id']]));
			$tpl->tplAssign('comment_num', $row['comment_num']);
			$tpl->tplAssign('attachment_num', $row['attachment_num']);
			$tpl->tplAssign('votes', $row['votes']);			
			$tpl->tplAssign('rating_img', $this->getRatingImg($row['rating'], $row['votes']));			
			
			//$active = (!$row['category_active']) ? 'none' : true;
			$tpl->tplAssign($this->getViewListVars($obj->get('id'), $obj->get('active')));
			
			$tpl->tplParse(array_merge($obj->get(), $this->msg), 'row');
		}
		
		$tpl->tplAssign($this->msg);
		$tpl->tplAssign($sort->toHtml());
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function &getSort() {
		//$sort = new TwoWaySort();
		$sort = new OneWaySort($_GET);
		$sort->default_order = 2;
		$sort->setTitleMsg('asc',  $this->msg['sort_asc_msg']);
		$sort->setTitleMsg('desc', $this->msg['sort_desc_msg']);
		$sort->setSortItem('votes_num_msg',  'votes', 'votes', $this->msg['votes_num_msg']);
		$sort->setSortItem('rating_msg',  'rating', 'rating', $this->msg['rating_msg']);
		$sort->setSortItem('entry_title_msg',  'title', 'title', $this->msg['entry_title_msg']);
		$sort->setSortItem('comment_num_msg', 'comments', 'comment_num', $this->msg['comment_num_msg']);
		$sort->setSortItem('attachment_num_msg', 'attachments', 'attachment_num', $this->msg['attachment_num_msg']);		
		$sort->setSortItem('hits_num_msg', 'hits', 'hits', $this->msg['hits_num_msg']);
		//$sort->setSortItem('sort_order_msg', 'sort_oder', 'sort_order', $this->msg['sort_order_msg'], 1);
		$sort->setSortItem('date_posted_msg', 'date', 'date_posted', $this->msg['date_posted_msg'], 2);
		$sort->setSortItem('status_msg','status', 'active', $this->msg['status_msg']);
		
		
		//$sort->getSql();
		//$sort->toHtml()
		return $sort;
	}
	
	
	function getFilter($manager, $categories) {

		$select = new FormSelect();
		$select->css_class = 'colorInput';
		$select->setSelectWidth(250);
		$select->setOnChangeSubmit(true);
		$select->setSelectName('filter');
		$select->setRange($manager->getCategorySelectRange($categories), 
		                  array('all'=>$this->msg['all_categories_msg']));
		
		$arr = $_GET; unset($arr[$select->select_name]);		

		
		$html = '<form action="" style="margin: 0px;">';
		$html .= http_build_hidden($arr);
		$html .= $select->select();
		$html .= '</form>';
		
		return $html;
	}
	
	
	function getFilterSql($manager, $categories) {
		
		// filter
		$arr = array();
		if(isset($_GET['filter']) && $_GET['filter'] != 'all') {
			
			$category_id = (int) $_GET['filter'];
			$child = array_merge($manager->getChilds($categories, $category_id), array($category_id));
			$child = implode(',', $child);
			
			$arr[] = "AND e_to_cat.category_id IN($child)";
		}
		
		return implode(" \n", $arr);
	}
	
	
	
	function getRatingImg($rate, $votes) {
		$str = '<img src="images/rating/rate_line_8px/rate_%s.gif" alt="" border="0">';
		$rate = round($rate);
		return ($votes) ? sprintf($str, $rate) : '';
	}
	
	
/*
	function getViewListVars($record_id = false, $active = false) {
		
		$row = parent::getViewListVars($record_id, $active);
		
		$row['attachment_link'] = sprintf('%s&%s=upload&id=%d', $row['common_link'], 'action', $record_id);
		return $row;		
	}
*/
}
?>