<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

require_once 'config.inc.php';
require_once 'common.inc.php';

session_name($conf['session_name']);
session_start();

$db =& DBUtil::connect($conf);

$reg =& Registry::instance();
$reg->setEntry('db', $db);
$reg->setEntry('tbl_pref', $conf['tbl_pref']);



$nav = new AppNavigation;
$nav->setPage('index.php');
$nav->setEqualAttrib('GET', 'module');
$nav->setSubEqualAttrib('GET', 'page');
$nav->setTemplate(APP_TMPL_DIR . 'top_menu.html');

$nav->setMenuMsg(AppMsg::getMenuMsgs(false, 'top'));
$nav->setMenu('all');
$nav->setOption('target', 'main');

if(empty($conf['extra']['file'])) {
	$nav->unsetMenuItem('file');
}

$tpl = new tplTemplatez(APP_TMPL_DIR . 'top_navigation.html');
$tpl->tplAssign('navigation', $nav->generate());
$tpl->tplAssign('username', $_SESSION['auth_']['username']);
$tpl->tplAssign('client_view_link', $conf['client_home_path']);
$tpl->tplAssign('base_href', $conf['home_path']);
$tpl->tplAssign('meta_charset', $conf['lang']['meta_charset']);

$tpl->tplAssign(AppMsg::getMsgs('common_msg.ini', false, false, false));

$tpl->tplParse();
$tpl->tplPrint();
?>