<?php
class DocumentParser
{
	
	function parseLink($str, $func, $article_id = false) {
		
		if(strpos($str, '[link:') === false) {
			return $str;
		}
	
		if($article_id) {
			$search = "/\[link:(\w+)\|(\d+)\]/e";
			return preg_replace($search, "call_user_func_array(\$func, array('$1', $article_id, '$2'))", $str);	
			
		} else {
			$search = "/\[link:(\w+)\|(\d+)\|?(\d{0,})\]/e";
			return preg_replace($search, "call_user_func_array(\$func, array('$1', '$2', '$3'))", $str);		
		}
	}
	
	
	function parseGlossaryItems($string, $manager) {
		
		$i = 0;
		$extensions = array('.php', '.asp', '.html', '.htm', '.xml', '.jsp');
		
		$ids = array();
		$glossary = &$manager->getGlossaryItems();
		
		foreach($glossary as $id => $item) {
			if(strpos(strtolower($string), strtolower($item)) !== false) {
				$ids[] = $id;
			}
		}
		
		// have items
		if($ids) {
			
			$glossary = &$this->stripVars($manager->getGlossaryDefinitions(implode(',', $ids)));
			
			foreach($glossary as $k => $v) {
				
				$preg = "~\b($k)\b(?![^<]*>)~i";
				preg_match_all($preg, $string, $matches);
				$num = ($v['display_once']) ? 1 : count($matches[0]);
				
				for($j=0;$j<$num;$j++){
										
					$id = 'glossary_' . $i++;
					$str = "<span class=\"glossaryItem\" onClick=\"ShowGlossaryItem('%s', '%s');\" onMouseOut=\"HideGlossaryItem('%s');\">$1</span>\n
					 		<span id=\"%s\" style=\"display: none;\"></span>";
					
					//$str = "<span class=\"glossaryItem\" onmouseover=\"return overlib('%s', CAPTION, 'URL', HAUTO, VAUTO, FGCOLOR, '#FFFF99', BGCOLOR, '#CC9900', WIDTH, 300);\" onmouseout=\"return nd();\">";
					//<a class="glossaryItem" href="/knowledgebase/glossary/#URL">URL</a></span>
					
					$search = "~\b(".$matches[0][$j].")\b(?!<\/span>\s)(?![^<]*>)~i";
					$v['definition'] = addslashes(str_replace(array("\r\n", "\n"), ' ', $v['definition']));			
					$replace = sprintf($str, $id, $v['definition'], $id, $id);					
					$string = preg_replace($search, $replace, $string, 1);
				}
			}
		}
		
		return $string;
	}
	
	
/*
	// gey body summary
	function getBodySummary(&$str, $num_signs) {
		
		//$search = "/<a(.*?)a>/si";
		//$replace = '';
		//$str = preg_replace($search, $replace, $str);
		
		$tags = array('<br>', '<BR>',  '< /br>', '<li>', '<p>', '<P>');
		$str = str_replace($tags, ' ', $str);

		$str = str_replace('  ', ' ', strip_tags($str));
		$str = explode(' ', $str);
		return implode(' ', array_slice($str, 0, $num_words)) . '...';
	}
*/
	
	function getSummary($str, $num_signs = '150') {
	
		if($num_signs == 'all') { return $str; }
		
		$values = array('<br>', '<BR>',  '< /br>', '<li>', '<p>', '<P>', '  ');
		$str = strip_tags(str_replace($values, ' ', $str)); 
		
		if(strlen($str) < $num_signs) { return $str; }
		
		return substr($str, 0, strrpos(substr($str, 0, $num_signs), ' ')) . '...';
	}
}
?>