<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

class KBClientView extends BaseView
{	

	var $working_dir;
	var $template_dir;
	var $template_view_dir;
	var $template;
	var $errors = array();
	var $form_data = array();
	
	var $msg = array();
	var $controller;
	var $style_css;
	var $meta_title;
	
	var $category_key;
	var $category_id;
	var $entry_key;
	var $entry_id;
	var $view_key;
	
	var $home_link = false; 			// use home link n navigation as link 
	var $category_nav_generate = true; 	// generate or not categories in navigation line
	var $settings = array();
	
	var $nav_delim = ' / ';
	var $display_categories = true;		// display form with categories and other staff with categories
	                                    // later we count categories and set var in KBClientView::getTop
	
	var $top_parent_id = 0;
	var $extra_breadcrumbs = array();
	
	
	function KBClientView(&$controller) {

		$reg =& Registry::instance();
		$this->conf =& $reg->getEntry('conf');
		//$this->se =& $reg->getEntry('conf');
	
		$this->controller = &$controller;
		
		$this->setTemplateDir($this->controller->getSetting('view_format'), 
		                      $this->controller->getSetting('view_template'));
		
		$this->setStyleCss($this->controller->getSetting('view_format'), 
		                   $this->controller->getSetting('view_template'),
						   $this->controller->getSetting('view_style'));
		$this->setMsg();
 
		$this->category_key = $controller->getRequestKey('category_id');
		$this->category_id = $controller->getRequestVar('category_id');
		$this->entry_key = $controller->getRequestKey('entry_id');
		$this->entry_id = $controller->getRequestVar('entry_id');
		$this->view_key = $controller->getRequestKey('view');
		$this->view_id = $controller->getRequestVar('view');
		$this->msg_key = $controller->getRequestKey('msg');
		$this->msg_id = $controller->getRequestVar('msg');
	}
	
	
	function setTemplateDir($view, $skin) {
		$this->template_dir = $this->controller->skin_dir . 'view_' . $view . '/' . $skin . '/';
	}	
	
	
	function setStyleCss($view, $skin, $style) {
		$this->style_css = $this->controller->skin_path . 'view_' . $view . '/' . $skin . '/' . $style . '.css';
	}
	
	
	function getMsgFile($file, $module = true) {
		require_once 'core/app/AppMsg.php';
		return ($module) ? AppMsg::getModuleMsgFile($module, $file) 
		                 : AppMsg::getCommonMsgFile($file);
	}
	
	function setMsg() {
		$file = $this->getMsgFile('client_msg.ini', 'knowledgebase');
		$this->msg = AppMsg::parseMsgs($file, false, false);
	}
	
	function addMsg($file, $module) {
		$file = $this->getMsgFile($file, $module);
		$this->msg = array_merge($this->msg, AppMsg::parseMsgs($file, false, false));
	}
	
	function getFormatedDate($timestamp, $format = null) {
		$format = ($format) ? $format : $this->conf['lang']['date_format'];
		return $this->_getFormatedDate($timestamp, $format);
	}	
	
	
	function getActionMsg($format = 'success') {
		
		if($this->msg_id) {
			
			require_once 'eleontev/HTML/BoxMsg.php';
			
			$file = $this->getMsgFile('client_after_action_msg.ini', 'knowledgebase');
			$msgs = AppMsg::parseMsgs($file, $this->msg_id, true);
			
			if($msgs) {
				return BoxMsg::factory($format, $msgs);
			}
		}
	}
	
	
	// true if commentable
	function isCommentable($manager, $var = true) {
		return (bool) ($manager->getSetting('allow_comments') && $var);
	}
	
	
	// true if ratingable
	function isRatingable($manager, $var = true) {
		return (bool) ($manager->getSetting('allow_rating') && $var);
	}	
	
	
	//function isRegisteredOnly($setting) {
	
	//}
	
	
	function pageByPage($limit, $sql, $per_page = false) {
		
		require_once 'eleontev/PageByPage.php';

		$bp = new PageByPage($limit);	
		$bp->action_page = $this->_getLink($this->view_id, $this->category_id, $this->entry_id);
		
		$bp->setMsg($this->msg['page_msg'], $this->msg['record_msg'], $this->msg['record_from_msg']);
		$bp->countAll($sql); 
		
		return $bp;
	}	
	
	
	function setErrors($errors) { 
		$this->errors = $errors;
	}	
	
	
	function getErrors() {
		require_once 'core/app/AppMsg.php';
		return AppMsg::errorBox($this->errors, $module = false);
	}
	
	
	// use it when wronng form submission
	function setFormData(&$arr) {
		$this->form_data = &$arr;
	}
	
	
	function &stripVars($values, $skip_keys = array(), $server_check = true) {
		return parent::stripVars($values, array('body'), $server_check);
	}
	
	
	// to popularte in form after wronng form submission
	function getFormData() {
		$this->form_data['required_sign'] = '<span class="requiredSign">*</span>';		
		return $this->form_data;
	}
	
	
	function _getItemImg($registered, $var, $category = false, $ext = false) {
		
		if($var && !$registered) {
			$tag = '<img src="%simages/icons/lock1.gif" alt="private" width="14" height="16" title="%s">';
			$tag = sprintf($tag, $this->controller->client_path, $this->msg['login_to_view_msg']);
		
		} elseif($category === 'file') {
			$tag = '<img src="%simages/filetypes/%s.png" alt="" width="18" height="16">';
			$tag = sprintf($tag, $this->controller->client_path, $ext);		
			
		} else {
			$tag = ($category) ? '<img src="%simages/icons/folder.gif" alt="" width="15" height="12">'
			                   : '<img src="%simages/icons/article.gif" alt="" width="11" height="14">';
			$tag = sprintf($tag, $this->controller->client_path);
		}

		return $tag;
	}
	
	
	function _getRating($var) {
		if($var) {
			$tag = '<img src="%simages/rating/rate_line_8px/rate_%s.gif" alt="rating">';
			$rate = sprintf($tag, $this->controller->client_path, round($var));
		} else {
			$rate = $this->msg['not_rated_msg']; 
		}
		
		return $rate;
	}
	
	
	function _getRateRange() {
		$file = $this->getMsgFile('rating_range_msg.ini', 'knowledgebase');
		return AppMsg::parseMsgs($file);
	}
	
	
	function _getFormatedNavigation($arr, $article_name = false) {		
		
		// skip category generate on some vies or if no categories (one only)	
		if($this->category_nav_generate && $this->display_categories) {
			$arr = TreeHelperUtil::getParentsById($arr, $this->category_id, 'name');
			$arr =& $this->stripVars($arr);
		} else {
			$arr = array();
			if($this->category_id) { $this->home_link = true; }
		}
					
		
		$view = false;
		$arr1 = array();
		if($arr || $this->home_link || $this->view_id == 'files') {
			$str = '<a href="%s" class="navigation">%s</a>';
			$arr1[] = sprintf($str, $this->_getLink(), $this->controller->getSetting('nav_title'));
			
			if($this->view_id == 'files') {
				$view = 'files';
				if($this->category_id || $this->msg_id == 'search') {
					$arr1[] = sprintf($str, $this->_getLink('files'), $this->msg['file_title_msg']);
				} else {
					$arr1[] = $this->msg['file_title_msg'];
				}
			}
			
		} else {
			$arr1[] = $this->controller->getSetting('nav_title');
		}
		
		
		// add article title if have it
		if($article_name !== false) {
			$article_name = (is_array($article_name)) ? $article_name : array($article_name);
			foreach($article_name as $k => $v) { $arr[$k] = $v; } 			
		}

		
/*
		if(is_array($article_name)) {
			foreach($article_name as $k => $v) { $arr[$k] = $v; }
			//$arr[] = '';
			
		} elseif($article_name !== false) {
			$arr[] = $article_name;
		}
*/
		
		
		$num = count($arr); 
		$i = 1;
		foreach($arr as $k => $v) {
			if($num != $i) {
				$k = (is_numeric($k)) ? $this->_getLink($view, $k, false) : $k;
				$arr1[] = sprintf('<a href="%s" class="navigation">%s</a>',$k, $v);
			} else {
				$arr1[] = sprintf('%s', $v);
			}
			
			$i++;
		}
		
		return implode($this->nav_delim, $arr1);
	}
	
	
	function _getLink($view = false, $category_id = false, $entry_id = false, $msg_key = false) {
		return $this->controller->getLink($view, $category_id, $entry_id, $msg_key); 
	}
	
	
	function &getTop(&$manager, $article_name = false, $parse_form = true) {
		
		$tpl = &new tplTemplatez($this->template_dir . 'top.html');
		
		// need to print msg if any
		$tpl->tplAssign('msg', $this->getActionMsg('error'));
		
		
		$c = &$manager->getCategoryModel();
		$simple_arr =& $this->stripVars($manager->categories);
		
		
		/*
		// one category - test values
		$simple_arr = array();
		$simple_arr[1]['id'] = 1;
        $simple_arr[1]['parent_id'] = 0;
        $simple_arr[1]['name'] = 'default';
        $simple_arr[1]['sort_order'] = 1;
		*/
		//echo "<pre>"; print_r($simple_arr); echo "</pre>";
		
/*
		//decide dispaly category staff or not
		if(count($simple_arr) == 1) {
			reset($simple_arr);
			if(strtolower($simple_arr[key($simple_arr)]['name']) == 'default') { 
				$this->display_categories = false;
			}
		}
*/
		
		
		$tpl->tplAssign('navigation', $this->_getFormatedNavigation($simple_arr, $article_name));
		
		// auth info
		if($manager->is_registered) {
			$tpl->tplAssign('username', AuthMember::getUsername());
			$tpl->tplAssign('logout_link', $this->_getLink('logout'));
			$tpl->tplAssign('username_link', $this->_getLink('member'));
			$tpl->tplAssign('delim', '|');	
			
			if(AuthMember::getCookie()) { 
				$this->msg['logout_msg'] = ''; 
				$tpl->tplAssign('delim', '');	
			}
			
			$tpl->tplSetNeeded('/logged');
		
		
		} elseif($manager->isUseRegistration()) {
			
			$tpl->tplAssign('login_link',    $this->_getLink('login'));
			$tpl->tplAssign('register_link', $this->_getLink('register'));
			
			$tpl->tplSetNeeded('/register');
		}
		
		
		// FORM
		if($parse_form) {
			
			if($manager->getSetting('allow_post_entry')) {
				$tpl->tplSetNeededGlobal('add_entry');
				$tpl->tplAssign('add_entry_link', $this->_getLink('contact', $this->category_id));
			}			
			
			if($manager->getSetting('show_glossary_link')) {
				if($manager->isGlossary()) {
					$tpl->tplSetNeededGlobal('glossary');
					$tpl->tplAssign('glossary_link', $this->_getLink('glossary'));
					$tpl->tplAssign('glossary_delim', ($manager->getSetting('allow_post_entry')) ? '|' : '');
				}		
			}
			
			if($manager->getSetting('show_file_link') && $manager->isExtra('file')) {
				$tpl->tplSetNeededGlobal('file');
				$tpl->tplAssign('file_link', $this->_getLink('files'));
				//$tpl->tplAssign('glossary_delim', ($manager->getSetting('allow_post_entry')) ? '|' : '');	
			}			
			

			// categories
			if($this->display_categories) {
				
				$select = new FormSelect();
				$select->select_tag = false;
				$select->setSelectWidth(200);
				$select->setRange($c->getSelectRange($simple_arr, $this->top_parent_id), array(0 => '____'));
				$tpl->tplAssign('category_select', $select->select($this->category_id));
				
				$tpl->tplSetNeededGlobal('category_select');	
			}


			//<input type="hidden" name="View" value="search">
			if($this->view_id == 'files') {
			
				if(!$this->controller->mod_rewrite) {
					$ar = array($this->view_key => 'files', $this->msg_key => 'search');
					$tpl->tplAssign('hidden_search', http_build_hidden($ar));
					
					$ar = array($this->view_key => 'files');
					$tpl->tplAssign('hidden_category', http_build_hidden($ar));					
				}				
			
				$tpl->tplAssign('form_search_action', $this->_getLink('files', $this->category_id, '', 'search'));
				$tpl->tplAssign('form_category_action', $this->_getLink('files'));
				$tpl->tplAssign('advanced_search_link', $this->_getLink('files', $this->category_id, '', 'search'));
			
			} else {
			
				if(!$this->controller->mod_rewrite) {
					$ar = array($this->view_key => 'search');
					$tpl->tplAssign('hidden_search', http_build_hidden($ar));
				}				
			
				$tpl->tplAssign('form_category_action', $this->_getLink());
				$tpl->tplAssign('form_search_action', $this->_getLink('search', $this->category_id));
				$tpl->tplAssign('advanced_search_link', $this->_getLink('search', $this->category_id));
			}

			
			
			$tpl->tplSetNeeded('/form');
		}
		
		
		$tpl->tplAssign($this->msg);
		$tpl->tplParse($_GET);
		
		return $tpl->tplPrint(1);
	}
}
?>