<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

class KBClientView_contact extends KBClientView_common
{

	var $found_entries = array();

	
	function &execute(&$manager) {
		
		$this->home_link = true;
		$this->meta_title = $this->msg['add_entry_msg'];
		$this->category_nav_generate = false; // not to generate categories in navigation line
		
		$data = $this->getTop($manager, $this->msg['add_entry_msg'], false);
		$data .= $this->getForm($manager);
		
		return $data;
	}
	

	function getForm(&$manager) {
		
		$tpl = &new tplTemplatez($this->template_dir . 'contact_form.html');
		
		// found
		if($this->found_entries) {
			
			$tpl->tplSetNeeded('/found_entries');
			
			foreach($this->found_entries as $k => $row) {
				
				$tpl->tplAssign('category_item_img', $this->_getItemImg($manager->is_registered, $row['category_private'], true));
				$tpl->tplAssign('category_link', $this->_getLink(false, $row['category_id']));
				
				$tpl->tplAssign('item_img', $this->_getItemImg($manager->is_registered, $row['category_private']));
				$tpl->tplAssign('updated_date', $this->getFormatedDate($row['ts_updated']));
				$tpl->tplAssign('entry_link', $this->_getLink('entry', $row['category_id'], $row['id']));
	
				$row['body'] = DocumentParser::getSummary($row['body'], 200);	
				
				$tpl->tplParse($row, 'found_row');
			}		
		}

		
															  
		$c = &$manager->getCategoryModel();
		$simple_arr = &$this->stripVars($manager->categories);
		$select_range = &$c->getSelectRange($simple_arr);
		
		// categories
		$select = new FormSelect();
		$select->setFormMethod($_POST);
		$select->select_tag = false;
		//$select->setSelectWidth(200);
		$select->setSelectName('category_id');
		$select->setRange($select_range, array(0=>'____'));
		
		$tpl->tplAssign('category_select', $select->select($this->category_id));
		
		$tpl->tplAssign('user_msg', $this->getErrors());		
		$tpl->tplAssign('action_link', $this->_getLink('all'));
		$tpl->tplAssign('cancel_link', $this->_getLink('', $this->category_id));
		
		
		if(!$manager->is_registered) {
			$tpl->tplSetNeeded('/not_registered');
		}
		
		$tpl->tplAssign($this->msg);
		$tpl->tplAssign($this->getFormData());	
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function validate($values, $manager) {
		 
		require_once 'eleontev/Validator.php';
		
		$v =& new Validator($values, false);
		
		// need to check if not registered
		if(!$manager->is_registered) {
			$v->requiredArray('required_msg', array('message', 'email'));
			$v->regex('email_msg', 'email', 'email');
		} else {
			$v->requiredArray('required_msg', array('message'));
		}
		
		return $v->getErrors();
	}
}
?>