<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

class KBClientView_glossary extends KBClientView_common
{

	function &execute(&$manager) {
		
		$this->home_link = true;
		$this->meta_title = $this->msg['glossary_msg'];
		
		$data = $this->getTop($manager, $this->msg['glossary_msg'], true);
		$data .= $this->getGlossaryList($manager);
		
		return $data;
	}
	
	
	function getGlossaryList($manager) {
		
		$tpl = &new tplTemplatez($this->template_dir . 'glossary_list.html');
		
		foreach($this->stripVars($manager->getGlossaryDefinitions()) as $k => $v) {
			$v['phrase'] = $k;
			$tpl->tplParse($v, 'row');
		}
		
		$tpl->tplAssign('base_href', $this->conf['client_home_path']);
		$tpl->tplAssign('print_link', $this->_getLink('print', '', '', 'glossary'));
		
		$tpl->tplParse($this->msg);
		return $tpl->tplPrint(1);
	}
}
?>