<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

require_once 'eleontev/HTML/DatePicker.php';

class KBClientView_search_form extends KBClientView_common
{
	

	function &execute(&$manager) {
		
		$this->home_link = true;
		$this->meta_title = $this->msg['advanced_search_msg'];
		$this->category_nav_generate = false; // not to generate categories in navigation line
		
		$data = $this->getTop($manager, $this->msg['advanced_search_msg'], false);
		$data .= $this->getForm($manager);
		
		return $data;	
	}
	

	function getForm($manager) {
		
		$tpl = &new tplTemplatez($this->template_dir . 'search_form.html');
		$tpl->tplAssign('base_href', $this->conf['client_home_path']);
		
		$c = &$manager->getCategoryModel();
		$simple_arr =& $manager->categories;
		
		
		$submit = (isset($_GET['period']));
		
		// categories
		$select = new FormSelect();
		$select->select_tag = false;
		$select->setRange($c->getSelectRange($simple_arr));
		
		$s = (isset($_GET['c'])) ? $_GET['c'] : $this->category_id;
		$tpl->tplAssign('category_select', $select->select($s));
		
		//period
		$select->setRange(AppMsg::getMsgs('ranges_msg.ini', false, 'search_period_range'));
		$tpl->tplAssign('period_select', $select->select(@$_GET['period']));		
		
		// search in
		$r = ($this->view_id == 'files') ? 'search_in_range_file' : 'search_in_range';
		$range = AppMsg::getMsgs('ranges_msg.ini', false, $r);
		if(!$manager->isExtra('file')) { unset($range['attachment']); }
		
		$select->setRange($range);
		$tpl->tplAssign('search_in_select', $select->select(@$_GET['in']));			
		
		// dates
		$picker = new DatePicker();
		$picker->setFormName('search_form');		// set form name
		$picker->setFormMethod($_GET);				// set form method
		$picker->setYearRange(date('Y')-1, date('Y'));
		$picker->css_class = 'colorInput';
		
		//$date = $picker->js();					// js function
		//$tpl->tplAssign('js_date_select', $date);
		
		$picker->setSelectName('from');
		//$picker->setDate($picker->toUnixDate($dates['from']));		
		$date = $picker->day();						// select tag with days
		$date .= $picker->month();					// select tag with mohth
		$date .= $picker->year();					// select tag with years
		$tpl->tplAssign('date_from_select', $date);
		
		$picker->setSelectName('to');	
		//$picker->setDate($picker->toUnixDate($dates['to']));	
		$date = $picker->day();						// select tag with days
		$date .= $picker->month();					// select tag with mohth
		$date .= $picker->year();					// select tag with years
		$tpl->tplAssign('date_till_select', $date);
		
		
		// checkboxes
		$s = ($submit) ? $this->getChecked(@$_GET['cp']) : 'checked';
		$tpl->tplAssign('cp_checked', $s);
		
		$f = (@$_GET['pv'] == 'u') ? 'pvu_checked' : 'pvp_checked';
		$tpl->tplAssign($f, 'checked');
		
		$tpl->tplAssign('qt_checked', $this->getChecked(@$_GET['qt']));
		
		
		if(!$this->controller->mod_rewrite) {
			$ar = ($this->view_id == 'files') ?  array($this->view_key => 'files', $this->msg_key => 'search')
			                                  :  array($this->view_key => 'search');
			$tpl->tplAssign('hidden', http_build_hidden($ar));			
		}	
		
		
		$tpl->tplAssign('action_link', $this->_getLink('all'));
		$tpl->tplAssign('cancel_link', $this->_getLink());
		$tpl->tplAssign('user_msg', $this->getErrors());
		
		$tpl->tplParse(array_merge($this->msg, $this->getFormData(), $_GET));
		return $tpl->tplPrint(1);
	}
	
	
	function getChecked($var) {
		return ($var) ? 'checked' : '';
	}
}
?>