<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

require_once $controller->working_dir . 'KBClientSearchGenerator.php';
require_once $controller->working_dir . 'KBClientSearchModel.php';

class KBClientView_search_list extends KBClientView_common
{
	
	function &execute(&$manager) {
		
		$this->home_link = true;
		$this->meta_title = $this->msg['search_result_msg'];
		$this->category_nav_generate = false;

		$top = (isset($_GET['period'])) ? false : true;
		if(!$top) {
			$arr = $_GET;
			unset($arr['s']);
			foreach($this->controller->query as $v) { unset($arr[$v]); }

			$link = $this->_getLink('search') . '?' . http_build_query($arr);
			$nav = array($link => $this->msg['advanced_search_msg'], $this->msg['search_result_msg']);
		} else {
			$nav = $this->msg['search_result_msg'];
		}
		
		$data = $this->getTop($manager, $nav, $top);
		$data .= $this->getEntryList($manager);
		
		return $data;	
	}
	
	
	function getSearchData() {
	
	}
	

	function getEntryList(&$manager) {	
	
		$search = &new KBClientSearchGenerator($_GET);
		$search_manager = &new KBClientSearchModel;
		
		$fulltext_sql = $search->getFullSearchSql('none', array($search_manager->tbl->file_entry,
														        $search_manager->tbl->attachment_to_entry));
		
		$sql[] = $fulltext_sql['where'];
		$sql[] = $search->getDateParams();
		
		// category
		if(!empty($search->values['c'])) {
			
			$c = &$manager->getCategoryModel();
			$categories =& $c->getSelectRecords($manager->getSetting('category_sort_order'));		
			$sql[] = $search->getCategorySql($categories);
		}
	
		$search_manager->setSqlParams('AND ' . implode(' AND ', $sql));
		$search_manager->setSqlParamsSelect($fulltext_sql['select']);
		$search_manager->setSqlParamsFrom($fulltext_sql['from']);
		$search_manager->setSqlParamsOrder($search->getOrderSql());
		

		$bp = new PageByPage($manager->getSetting('num_entries_per_page'), $_GET);	
		$bp->setMsg($this->msg['page_msg'], $this->msg['record_msg'], $this->msg['record_from_msg']);
		$bp->countAll($search_manager->getEntryCountSql()); 		
		
		
		$rows = &$search_manager->getEntryList($bp->limit, $bp->offset);
		return $this->_parseArticleList($this->stripVars($rows), $bp->shortNavigate());
	}
	
	
	// parse data with articles
	function &_parseArticleList($rows, $by_page) {
		
		$tpl = &new tplTemplatez($this->template_dir . 'search_list.html');
		
		if(!$rows) {
		
			require_once 'eleontev/HTML/BoxMsg.php';
		
			$msg = new BoxMsg();
			$msg->setMsg('body', $this->msg['no_search_result_msg']);
		
			$tpl->tplAssign('msg', $msg->get());
		
		} else {
		
			foreach($rows as $k => $row) {
				
				$tpl->tplAssign('category_item_img', $this->_getItemImg($manager->is_registered, $row['category_private'], true));
				$tpl->tplAssign('category_link', $this->_getLink($row['category_id']));
				
				$tpl->tplAssign('item_img', $this->_getItemImg($manager->is_registered, $row['category_private']));
				$tpl->tplAssign('updated_date', $this->getFormatedDate($row['ts_updated']));
				$tpl->tplAssign('entry_link', $this->_getLink('entry', $row['category_id'], $row['id']));
	
				$row['body'] = DocumentParser::getSummary($row['body'], 200);
				
				
				///if($manager->getSetting('show_hits')) {
				//	$tpl->tplSetNeeded('row/show_hits');
				//}
				
				
				//if($this->isRatingable($manager, $row['ratingable'])) {
				//	$tpl->tplAssign('rating', $this->_getRating($row['rating']));
				//} else {
				//	$tpl->tplAssign('rating', '');
				//}	
				
				
				//if($this->isCommentable($manager, $row['commentable'])) {
				//	$tpl->tplSetNeeded('row/show_comments');
				//}			
				
				$tpl->tplParse(array_merge($row, $this->msg), 'row');
			} 	
		}
	
		$tpl->tplAssign('page_by_page', $by_page);
		$tpl->tplAssign('search_result_msg', $this->msg['search_result_msg']);

		$tpl->tplParse();
		
		return $tpl->tplPrint(1);
	}
}
?>