#
# Table structure for table 's_kb_category'
#

DROP TABLE IF EXISTS s_kb_category;
CREATE TABLE s_kb_category (
  id int(10) unsigned NOT NULL auto_increment,
  parent_id int(10) unsigned NOT NULL default '0',
  name varchar(100) NOT NULL default '',
  description text NOT NULL,
  sort_order tinyint(3) unsigned NOT NULL default '0',
  commentable tinyint(1) NOT NULL default '1',
  ratingable tinyint(1) NOT NULL default '1',
  private tinyint(1) NOT NULL default '0',
  active tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (id),
  KEY parent_id (parent_id)
) ENGINE=MyISAM;



#
# Table structure for table 's_kb_comment'
#

DROP TABLE IF EXISTS s_kb_comment;
CREATE TABLE s_kb_comment (
  id int(10) unsigned NOT NULL auto_increment,
  entry_id int(10) unsigned NOT NULL default '0',
  user_id int(10) unsigned default NULL,
  name varchar(50) NOT NULL default '',
  email varchar(50) NOT NULL default '',
  comment text NOT NULL,
  date_posted datetime NOT NULL default '0000-00-00 00:00:00',
  active tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (id),
  KEY entry_id (entry_id),
  KEY NewIndex (user_id)
) ENGINE=MyISAM;



#
# Table structure for table 's_kb_entry'
#

DROP TABLE IF EXISTS s_kb_entry;
CREATE TABLE s_kb_entry (
  id int(10) unsigned NOT NULL auto_increment,
  author_id int(10) unsigned NOT NULL default '0',
  updater_id int(10) unsigned NOT NULL default '0',
  title text NOT NULL,
  body MEDIUMTEXT NOT NULL,
  date_updated timestamp NOT NULL,
  date_posted datetime NOT NULL default '0000-00-00 00:00:00',
  hits int(10) unsigned NOT NULL default '0',
  sort_order smallint(5) unsigned NOT NULL default '1',
  active tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (id),
  KEY updater_id (updater_id),
  KEY author_id (author_id),
  FULLTEXT KEY title_only (title),
  FULLTEXT KEY title (title,body)
) ENGINE=MyISAM;



#
# Table structure for table 's_kb_entry_to_category'
#

DROP TABLE IF EXISTS s_kb_entry_to_category;
CREATE TABLE s_kb_entry_to_category (
  entry_id int(10) unsigned NOT NULL default '0',
  category_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (entry_id,category_id)
) ENGINE=MyISAM;



#
# Table structure for table 's_kb_glossary'
#

DROP TABLE IF EXISTS s_kb_glossary;
CREATE TABLE s_kb_glossary (
  id int(10) unsigned NOT NULL auto_increment,
  phrase varchar(100) NOT NULL default '',
  definition text NOT NULL,
  display_once tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (id)
) ENGINE=MyISAM;



#
# Table structure for table 's_kb_rating'
#

DROP TABLE IF EXISTS s_kb_rating;
CREATE TABLE s_kb_rating (
  entry_id int(10) unsigned NOT NULL default '0',
  votes int(10) unsigned NOT NULL default '0',
  rate bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (entry_id)
) ENGINE=MyISAM;



#
# Table structure for table 's_member'
#

DROP TABLE IF EXISTS s_member;
CREATE TABLE s_member (
  id smallint(6) NOT NULL auto_increment,
  username varchar(30) NOT NULL default '',
  password varchar(32) NOT NULL default '',
  first_name varchar(50) NOT NULL default '',
  middle_name varchar(50) NOT NULL default '',
  last_name varchar(100) NOT NULL default '',
  email varchar(100) NOT NULL default '',
  phone varchar(20) NOT NULL default '',
  date_registered date NOT NULL default '0000-00-00',
  active tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (id),
  UNIQUE KEY login (username),
  KEY pass (password(2))
) ENGINE=MyISAM;



#
# Table structure for table 's_priv'
#

DROP TABLE IF EXISTS s_priv;
CREATE TABLE s_priv (
  id int(10) unsigned NOT NULL auto_increment,
  user_id int(10) unsigned NOT NULL default '0',
  priv_name_id smallint(6) NOT NULL default '0',
  grantor int(11) NOT NULL default '0',
  timestamp timestamp NOT NULL,
  PRIMARY KEY  (id),
  KEY user (user_id),
  KEY name_priv_id (priv_name_id)
) ENGINE=MyISAM;



#
# Dumping data for table 's_priv'
#

INSERT INTO s_priv VALUES("1", "1", "1", "0", "2005-10-12 00:00:00");
INSERT INTO s_priv VALUES("2", "2", "2", "0", "2006-03-25 11:05:00");
INSERT INTO s_priv VALUES("3", "3", "3", "0", "2006-02-13 21:52:08");
INSERT INTO s_priv VALUES("4", "4", "4", "0", "2006-05-31 19:58:55");


#
# Table structure for table 's_priv_module'
#

DROP TABLE IF EXISTS s_priv_module;
CREATE TABLE s_priv_module (
  id smallint(6) NOT NULL default '0',
  parent_id smallint(6) NOT NULL default '0',
  parent_setting_id tinyint(1) NOT NULL default '0',
  module_name varchar(30) NOT NULL default '0',
  menu_name varchar(50) NOT NULL default '',
  use_in_sub_menu enum('NO','YES_DEFAULT','YES_NOT_DEFAULT') default NULL,
  as_sub_menu tinyint(1) NOT NULL default '0',
  by_default varchar(30) NOT NULL default '',
  own_priv tinyint(1) NOT NULL default '0',
  check_priv tinyint(1) NOT NULL default '1',
  active tinyint(1) NOT NULL default '1',
  sort_order smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) ENGINE=MyISAM;



#
# Dumping data for table 's_priv_module'
#

INSERT INTO s_priv_module VALUES("0", "0", "0", "all", "", "NO", "0", "", "0", "1", "1", "0");
INSERT INTO s_priv_module VALUES("1", "0", "0", "user", "Administrators", "NO", "0", "user", "0", "1", "1", "20");
INSERT INTO s_priv_module VALUES("3", "0", "0", "setting", "Settings", "NO", "0", "kb_setting", "0", "1", "1", "21");
INSERT INTO s_priv_module VALUES("5", "0", "0", "member", "Members", "NO", "0", "member", "0", "1", "1", "2");
INSERT INTO s_priv_module VALUES("100", "0", "3", "knowledgebase", "KnowledgeBase", "YES_DEFAULT", "0", "", "1", "1", "1", "1");
INSERT INTO s_priv_module VALUES("2", "1", "0", "privilege", "Pivilege", "NO", "1", "", "0", "1", "0", "1");
INSERT INTO s_priv_module VALUES("101", "100", "0", "kb_entry", "Questions", "NO", "0", "", "0", "1", "1", "1");
INSERT INTO s_priv_module VALUES("102", "100", "0", "kb_category", "Categories", "NO", "0", "", "0", "1", "1", "15");
INSERT INTO s_priv_module VALUES("104", "100", "0", "kb_comment", "Comments", "NO", "0", "", "0", "1", "1", "3");
INSERT INTO s_priv_module VALUES("105", "100", "0", "kb_glossary", "Glossary", "NO", "0", "", "0", "1", "1", "4");
INSERT INTO s_priv_module VALUES("131", "3", "3", "sys_setting", "System", "NO", "0", "", "0", "1", "0", "0");
INSERT INTO s_priv_module VALUES("10", "1", "0", "user", "Administrators", "NO", "0", "", "0", "1", "1", "0");
INSERT INTO s_priv_module VALUES("107", "100", "0", "kb_user_question", "User Questions", "NO", "0", "", "0", "1", "0", "11");
INSERT INTO s_priv_module VALUES("130", "3", "0", "kb_setting", "KnowledgeBase", "NO", "0", "", "0", "1", "1", "1");
INSERT INTO s_priv_module VALUES("108", "100", "0", "kb_attachment", "Attachments", "NO", "0", "", "0", "1", "0", "20");
INSERT INTO s_priv_module VALUES("200", "0", "3", "file", "Files", "NO", "0", "file_entry", "0", "1", "1", "2");
INSERT INTO s_priv_module VALUES("202", "200", "0", "file_category", "Categories", "NO", "0", "", "0", "1", "1", "2");
INSERT INTO s_priv_module VALUES("109", "100", "0", "kb_client", "Client View", "NO", "0", "", "0", "0", "1", "23");
INSERT INTO s_priv_module VALUES("132", "3", "0", "letter_template", "Letter Template", "NO", "0", "", "0", "1", "0", "10");
INSERT INTO s_priv_module VALUES("133", "3", "0", "file_setting", "Files", "NO", "0", "", "0", "1", "1", "5");
INSERT INTO s_priv_module VALUES("50", "5", "0", "member", "Members", "NO", "0", "", "0", "1", "1", "0");
INSERT INTO s_priv_module VALUES("51", "5", "0", "member_role", "Roles", "NO", "0", "", "0", "1", "0", "2");
INSERT INTO s_priv_module VALUES("11", "1", "0", "user_role", "Roles", "NO", "0", "", "0", "1", "0", "2");
INSERT INTO s_priv_module VALUES("300", "0", "0", "ticket", "Tickets", "NO", "0", "", "0", "1", "0", "0");
INSERT INTO s_priv_module VALUES("201", "200", "0", "file_entry", "Files", "NO", "0", "", "0", "1", "1", "1");


#
# Table structure for table 's_priv_name'
#

DROP TABLE IF EXISTS s_priv_name;
CREATE TABLE s_priv_name (
  id smallint(5) unsigned NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  description text NOT NULL,
  active tinyint(1) NOT NULL default '1',
  statusable enum('yes','no') NOT NULL default 'yes',
  info_editable enum('yes','no') NOT NULL default 'yes',
  priv_editable enum('yes','no') NOT NULL default 'yes',
  deleteable enum('yes','no') NOT NULL default 'yes',
  sort_order smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) ENGINE=MyISAM;



#
# Dumping data for table 's_priv_name'
#

INSERT INTO s_priv_name VALUES("1", "Admin", "User has all privileges.", "1", "no", "yes", "yes", "no", "1");
INSERT INTO s_priv_name VALUES("2", "KnowledgeBase Moderator", "User has all privileges for knowledgebase.", "1", "yes", "yes", "yes", "yes", "2");
INSERT INTO s_priv_name VALUES("3", "KnowledgeBase Editor", "User has privileges for Knowledgebase\r\n(Edit, Delete - Questions, Comments, Site Visitors questions)", "1", "yes", "yes", "yes", "yes", "3");
INSERT INTO s_priv_name VALUES("4", "Knowledgebase Author", "", "1", "yes", "yes", "yes", "yes", "4");


#
# Table structure for table 's_priv_rule'
#

DROP TABLE IF EXISTS s_priv_rule;
CREATE TABLE s_priv_rule (
  id int(10) unsigned NOT NULL auto_increment,
  priv_name_id smallint(6) NOT NULL default '0',
  priv_module_id smallint(6) NOT NULL default '0',
  what_priv set('select','self_select','insert','update','self_update','status','self_status','delete','self_delete') NOT NULL default '',
  apply_to_child tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY Table_priv (priv_module_id),
  KEY name_priv_id (priv_name_id)
) ENGINE=MyISAM;



#
# Dumping data for table 's_priv_rule'
#

INSERT INTO s_priv_rule VALUES("1", "1", "0", "select,insert,update,status,delete", "0");
INSERT INTO s_priv_rule VALUES("2", "2", "100", "select,insert,update,status,delete", "1");
INSERT INTO s_priv_rule VALUES("3", "2", "1", "self_select,self_update", "0");
INSERT INTO s_priv_rule VALUES("4", "3", "1", "self_select,self_update", "0");
INSERT INTO s_priv_rule VALUES("5", "3", "101", "select,insert,update,status,delete", "0");
INSERT INTO s_priv_rule VALUES("6", "3", "104", "select,insert,update,status,delete", "0");
INSERT INTO s_priv_rule VALUES("7", "3", "107", "select,insert,update,status,delete", "0");
INSERT INTO s_priv_rule VALUES("11", "2", "200", "select,insert,update,status,delete", "1");
INSERT INTO s_priv_rule VALUES("9", "3", "108", "select,insert,update,status,delete", "0");
INSERT INTO s_priv_rule VALUES("10", "2", "5", "select,insert,update,status,delete", "0");
INSERT INTO s_priv_rule VALUES("12", "3", "5", "select", "0");
INSERT INTO s_priv_rule VALUES("13", "3", "201", "select,insert,update,status,delete", "0");
INSERT INTO s_priv_rule VALUES("14", "4", "1", "self_select,self_update", "0");
INSERT INTO s_priv_rule VALUES("15", "4", "101", "self_select,insert,self_update,self_status,self_delete", "0");
INSERT INTO s_priv_rule VALUES("16", "4", "201", "self_select,insert,self_update,self_status,self_delete", "0");


#
# Table structure for table 's_setting'
#

DROP TABLE IF EXISTS s_setting;
CREATE TABLE s_setting (
  id int(10) unsigned NOT NULL auto_increment,
  module_id int(10) unsigned NOT NULL default '0',
  input_id int(10) unsigned NOT NULL default '0',
  options varchar(100) NOT NULL default '',
  setting_key varchar(255) NOT NULL default '',
  messure varchar(10) NOT NULL default '',
  range varchar(255) NOT NULL default '',
  default_value varchar(255) NOT NULL default '',
  sort_order float NOT NULL default '0',
  active tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (id)
) ENGINE=MyISAM;



#
# Dumping data for table 's_setting'
#

INSERT INTO s_setting VALUES("1", "100", "1", "", "allow_comments", "", "0,1,2", "1", "12", "1");
INSERT INTO s_setting VALUES("2", "100", "4", "", "allow_rating", "", "", "1", "14", "1");
INSERT INTO s_setting VALUES("3", "100", "1", "", "allow_post_entry", "", "0,1,2", "1", "11", "1");
INSERT INTO s_setting VALUES("4", "100", "1", "", "num_most_viewed_entries", "", "0,3,5,10,15", "5", "8", "1");
INSERT INTO s_setting VALUES("5", "100", "1", "", "num_recently_posted_entries", "", "0,3,5,10,15", "5", "7", "1");
INSERT INTO s_setting VALUES("6", "100", "1", "", "num_entries_per_page", "", "10,15,20", "10", "6", "1");
INSERT INTO s_setting VALUES("7", "100", "1", "", "view_format", "", "default, faq_1", "default", "4", "1");
INSERT INTO s_setting VALUES("8", "100", "4", "", "show_hits", "", "", "1", "15", "1");
INSERT INTO s_setting VALUES("9", "100", "4", "", "comment_status", "", "", "1", "13", "1");
INSERT INTO s_setting VALUES("10", "100", "2", "size=\"50\"", "site_title", "", "", "Your Company / Knowledgebase", "1", "1");
INSERT INTO s_setting VALUES("11", "100", "2", "size=\"50\"", "support_email", "", "", "your@email.com", "2", "1");
INSERT INTO s_setting VALUES("12", "100", "4", "", "show_glossary_link", "", "", "1", "16", "1");
INSERT INTO s_setting VALUES("13", "100", "2", "size=\"50\"", "page_to_load", "", "", "Default", "3", "1");
INSERT INTO s_setting VALUES("14", "100", "1", "", "category_sort_order", "", "name,sort_order", "sort_order", "10", "1");
INSERT INTO s_setting VALUES("15", "100", "4", "", "show_send_link", "", "", "1", "17", "1");
INSERT INTO s_setting VALUES("16", "100", "1", "", "show_num_entries", "", "0,1,2", "1", "10.1", "1");
INSERT INTO s_setting VALUES("17", "100", "4", "", "show_title_nav", "", "", "1", "18", "1");
INSERT INTO s_setting VALUES("18", "100", "1", "", "home_page_format", "", "1,2,3,4", "1", "5", "0");
INSERT INTO s_setting VALUES("19", "100", "2", "size=\"50\"", "nav_title", "", "", "Knowledgebase", "1.2", "1");
INSERT INTO s_setting VALUES("20", "200", "2", "size=\"50\"", "file_dir", "", "", "[document_root]/kb_file/", "10", "1");
INSERT INTO s_setting VALUES("21", "200", "4", "", "file_extract", "", "", "1", "15", "1");
INSERT INTO s_setting VALUES("22", "200", "2", "size=\"50\"", "file_denied_extensions", "", "php,php3,php5,phtml,asp,aspx,ascx,jsp,cfm,cfc,pl,bat,exe,dll,reg,cgi", "php,php3,php5,phtml,asp,aspx,ascx,jsp,cfm,cfc,pl,bat,exe,dll,reg,cgi", "13", "1");
INSERT INTO s_setting VALUES("23", "200", "2", "", "file_max_filesize", "", "", "2048", "11", "1");
INSERT INTO s_setting VALUES("24", "200", "1", "", "file_store", "", "dir,db", "dir", "0", "0");
INSERT INTO s_setting VALUES("25", "200", "2", "size=\"50\"", "file_allowed_extensions", "", "", "", "12", "1");
INSERT INTO s_setting VALUES("26", "200", "1", "", "file_rename_policy", "", "date_Ymd-His,date_Ymd,date_Y,suffics_3", "date_Ymd-His", "10", "0");
INSERT INTO s_setting VALUES("27", "200", "1", "", "num_most_viewed_entries", "", "0,3,5,10,15", "5", "3", "1");
INSERT INTO s_setting VALUES("28", "200", "1", "", "num_recently_posted_entries", "", "0,3,5,10,15", "5", "2", "1");
INSERT INTO s_setting VALUES("29", "200", "1", "", "num_entries_per_page", "", "10,15,20", "10", "1", "1");
INSERT INTO s_setting VALUES("30", "200", "1", "", "category_sort_order", "", "name,sort_order", "sort_order", "4", "1");
INSERT INTO s_setting VALUES("31", "200", "1", "", "show_num_entries", "", "0,1,2", "1", "5", "1");
INSERT INTO s_setting VALUES("34", "100", "4", "", "show_file_link", "", "", "1", "19", "1");
INSERT INTO s_setting VALUES("33", "100", "4", "", "kb_register_access", "", "", "0", "3.1", "1");
INSERT INTO s_setting VALUES("35", "100", "1", "", "private_policy", "", "1,2", "2", "3.2", "1");
INSERT INTO s_setting VALUES("36", "200", "1", "", "private_policy", "", "1,2", "2", "0", "1");


#
# Table structure for table 's_setting_input'
#

DROP TABLE IF EXISTS s_setting_input;
CREATE TABLE s_setting_input (
  id int(10) unsigned NOT NULL auto_increment,
  input varchar(20) NOT NULL default '',
  PRIMARY KEY  (id)
) ENGINE=MyISAM;



#
# Dumping data for table 's_setting_input'
#

INSERT INTO s_setting_input VALUES("1", "select");
INSERT INTO s_setting_input VALUES("2", "text");
INSERT INTO s_setting_input VALUES("3", "textarea");
INSERT INTO s_setting_input VALUES("4", "checkbox");
INSERT INTO s_setting_input VALUES("5", "password");


#
# Table structure for table 's_setting_to_value'
#

DROP TABLE IF EXISTS s_setting_to_value;
CREATE TABLE s_setting_to_value (
  setting_id int(10) unsigned NOT NULL default '0',
  setting_value varchar(255) NOT NULL default '',
  PRIMARY KEY  (setting_id)
) ENGINE=MyISAM;



#
# Table structure for table 's_user'
#

DROP TABLE IF EXISTS s_user;
CREATE TABLE s_user (
  id smallint(6) NOT NULL auto_increment,
  username varchar(30) NOT NULL default '',
  password varchar(32) NOT NULL default '',
  first_name varchar(50) NOT NULL default '',
  middle_name varchar(50) NOT NULL default '',
  last_name varchar(100) NOT NULL default '',
  email varchar(100) NOT NULL default '',
  phone varchar(20) NOT NULL default '',
  active tinyint(1) NOT NULL default '0',
  editable tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY login (username),
  KEY pass (password(2))
) ENGINE=MyISAM;



#
# Dumping data for table 's_user'
#

INSERT INTO s_user VALUES("1", "admin", "fe01ce2a7fbac8fafaed7c982a04e229", "Admin", "", "Admin", "admin@site.com", "", "1", "1");
INSERT INTO s_user VALUES("2", "moderator", "fe01ce2a7fbac8fafaed7c982a04e229", "Moderator", "", "Moderator", "moderator@site.com", "111-111", "1", "1");
INSERT INTO s_user VALUES("3", "editor", "fe01ce2a7fbac8fafaed7c982a04e229", "Editor", "", "Editor", "editor@site.com", "", "1", "1");
INSERT INTO s_user VALUES("4", "author", "fe01ce2a7fbac8fafaed7c982a04e229", "Author", "", "Author", "author@site.com", "", "1", "1");
