<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

// full path to admin directory
$app_dir = $_SERVER['DOCUMENT_ROOT'] . '/kb/admin/';


/* DO NOT MODIFY */
$view_format   = 'default'; 	// view format (more formats will be soon)
$view_template = 'default'; 	// looking for templates in this dir
$view_style    = 'default';		// looking for css with this name (default.css)


require_once $app_dir . 'config.inc.php';
require_once $conf['client_root_dir'] . 'client/inc/common.inc.php';

//session_name($conf['session_name']);
session_start();


$client_dir = $conf['client_root_dir'] . 'client/inc/';
$skin_dir   = $conf['client_root_dir'] . 'client/skin/';
$skin_path  = $conf['client_home_path'] . 'client/skin/';
require_once $client_dir . 'KBClientModel.php';
require_once $client_dir . 'KBClientPageRenderer.php';
require_once $client_dir . 'KBClientController.php';
require_once $client_dir . 'KBClientView.php';
require_once $client_dir . 'KBClientMailer.php';
require_once $client_dir . 'DocumentParser.php';



$db =& DBUtil::connect($conf);

$reg =& Registry::instance();
$reg->setEntry('db', $db);
$reg->setEntry('tbl_pref', $conf['tbl_pref']);
$reg->setEntry('conf', $conf);
$reg->setEntry('extra', $conf['extra']);

$setting = &KBClientModel::getSettings(100);
$setting['view_format'] = $setting['view_format'];
$setting['view_template'] = $view_template; 	// looking for template in this dir
$setting['view_style'] = $view_style;			// looking for css in this dir


require_once $client_dir . $setting['view_format'] . '/KBClientView_common.php';
require_once $client_dir . $setting['view_format'] . '/KBClientModel_common.php';


$manager = &new KBClientModel_common;
$manager->is_registered = AuthMember::isAuth();
$manager->user_id = AuthMember::getUserId();
$manager->setting = &$setting;
$manager->setCategories();
//$manager->setSqlParams($manager->_getEntryPrivateSqlParams());
//echo "<pre>"; print_r($manager->setting); echo "</pre>";


$controller = &new KBClientController();
//$controller->setDirs($conf, $setting);
$controller->client_path = $conf['client_home_path'] . 'client/';
$controller->working_dir = $client_dir;
$controller->common_dir  = $client_dir . $setting['view_template'] . '/';
$controller->skin_dir  = $skin_dir;
$controller->skin_path = $skin_path;
$controller->setSettings($setting);
$controller->setModRewrite(!empty($_SERVER['MY_REWRITE']) || $conf['use_mod_rewrite']);
//$controller->setModRewrite(0);
//$controller->extra_params = array('a'=>'28', 'b'=>'137');
//echo "<pre>"; print_r($controller); echo "</pre>";


// do auth by cookie if set
if(AuthMember::getCookie() && !AuthMember::isAuth() && $manager->isUseRegistration()) {
	$auth = new AuthMember;
	$auth->setTable($manager->tbl->user);
	$auth->doAuthByCookie();
	$controller->go('all');
}


// page render
require_once $client_dir . $setting['view_format'] . '/PageController.php';


$page = new KBClientPageRenderer($view, $manager, $conf);
$page->display();


if($conf['debug_info']) {
	echo getDebugInfo();
}

if($conf['debug_speed']) {
	timeprint("%min %max graf");
}


ob_end_flush();
?>